{
  open Lexing
  open Myparser
  
  exception SyntaxError of string

  let next_line lexbuf =
    let pos = lexbuf.lex_curr_p in
    lexbuf.lex_curr_p <- { pos with pos_bol = lexbuf.lex_curr_pos;
                                    pos_lnum = pos.pos_lnum + 1 }
}

rule read =
  parse
  | [' ' '\t']+ { read lexbuf }
  | '\n' { next_line lexbuf; read lexbuf }
  | ['0'-'9']+ { INT_LIT (int_of_string (Lexing.lexeme lexbuf)) }
  | '+' { PLUS }
  | '*' { MULT }
  | '(' { LPAREN }
  | ')' { RPAREN }
  | _ { raise (SyntaxError ("Unexpected character: " ^ Lexing.lexeme lexbuf)) }
  | eof { EOF }
  
  
  
  
  
  
  
  
