%token PLUS
%token MULT
%token LPAREN
%token RPAREN
%token <int> INT_LIT
%token EOF

%start <Expr.expr> prog

%%

prog:
  | e = expr; EOF { e }

expr:
  | s = INT_LIT { Expr.IntLit(s) }
  | e1 = expr; PLUS; e2 = expr { Expr.Plus(e1, e2) }
  | e1 = expr; MULT; e2 = expr { Expr.Mult(e1, e2) }
  | LPAREN; e = expr; RPAREN { e }
  (* ^^^ What expressions look like, "on the wire" *)
